(define (run-benchmark name count run ok?)
  (if (not (ok? (run-bench name count run ok?)))
    (begin
      (display "*** wrong result ***")
      (newline))))

(define (run-bench name count run ok?)
  (let loop ((i 0) (result (list 'undefined)))
    (if (< i count)
      (loop (+ i 1) (run))
      result)))

(define (fatal-error . args)
  (for-each display args)
  (newline)
  (exit 1))

(define FLOAT+ +)
(define FLOAT- -)
(define FLOAT* *)
(define FLOAT/ /)

(define FLOAT= =)
(define FLOAT< <)
(define FLOAT<= <=)
(define FLOAT> >)
(define FLOAT>= >=)

(define FLOATnegative? negative?)
(define FLOATpositive? positive?)
(define FLOATzero? zero?)

(define FLOATabs abs)
(define FLOATsin sin)
(define FLOATcos cos)
(define FLOATatan atan)
(define FLOATsqrt sqrt)

;;; (define bitwise-or logior)
;;; (define bitwise-and logand)
;;; (define bitwise-not lognot)

(define (ANGLE . args)
  (fatal-error "ANGLE is not implemented"))
(define (DENOMINATOR . args)
  (fatal-error "IMAG-PART is not implemented"))
(define (IMAG-PART . args)
  (fatal-error "IMAG-PART is not implemented"))
(define (MAGNITUDE . args)
  (fatal-error "MAGNITUDE is not implemented"))
(define (MAKE-POLAR . args)
  (fatal-error "MAKE-POLAR is not implemented"))
(define (MAKE-RECTANGULAR . args)
  (fatal-error "MAKE-RECTANGULAR is not implemented"))
(define (NUMERATOR . args)
  (fatal-error "NUMERATOR is not implemented"))
(define (RATIONALIZE . args)
  (fatal-error "RATIONALIZE is not implemented"))
(define (REAL-PART . args)
  (fatal-error "REAL-PART is not implemented"))
