;==============================================================================

; file: "_multi.scm"

; Copyright (C) 1994-1997 by Marc Feeley, All Rights Reserved.

(##include "header.scm")

(##declare (not interrupts-enabled))

;------------------------------------------------------------------------------

; Procedures to support multitasking

; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

; (##add-gc-interrupt-job thunk) can be called to add another job to do
; after a GC.  (##clear-gc-interrupt-jobs) clears the jobs.

(define ##gc-interrupt-jobs #f)

(define (##add-gc-interrupt-job thunk)
  (##add-job ##gc-interrupt-jobs thunk))

(define (##clear-gc-interrupt-jobs)
  (set! ##gc-interrupt-jobs (##make-jobs)))

(##clear-gc-interrupt-jobs)

(define ##gc-interrupt #f)
(set! ##gc-interrupt
  (lambda ()
    (##gc-finalization)
    (##invoke-jobs ##gc-interrupt-jobs)))

; (##add-timer-interrupt-job thunk) can be called to add another
; job to do on timer interrupts.  (##clear-timer-interrupt-jobs) clears
; the jobs.

(define ##timer-interrupt-jobs #f)

(define (##add-timer-interrupt-job thunk)
  (##add-job ##timer-interrupt-jobs thunk))

(define (##clear-timer-interrupt-jobs)
  (set! ##timer-interrupt-jobs (##make-jobs)))

(##clear-timer-interrupt-jobs)

; (##timer-interrupt) is called periodically, based on VIRTUAL (cpu) time.

(define ##timer-interrupt-enable #f)
(set! ##timer-interrupt-enable #t)

(define ##timer-interrupt #f)
(set! ##timer-interrupt
  (lambda ()
    (if (##eq? ##timer-interrupt-enable #t)
      (##invoke-jobs ##timer-interrupt-jobs))))

;------------------------------------------------------------------------------
